diff --git a/gcc/m2/pge-boot/Gpge.cc b/gcc/m2/pge-boot/Gpge.cc
index 1fbf961992e..e231abeea47 100644
--- a/gcc/m2/pge-boot/Gpge.cc
+++ b/gcc/m2/pge-boot/Gpge.cc
@@ -4862,10 +4862,10 @@ static void Defs (pge_SetOfStop stopset)
 
 
 /*
-   ExtBNF := 'BNF' { Production  } 'FNB' 
+   ExtBNF := 'BNF' { Production  } 'FNB'
 
    first  symbols:BNFtok
-   
+
    cannot reachend
 */
 
@@ -4882,10 +4882,10 @@ static void ExtBNF (pge_SetOfStop stopset)
 
 
 /*
-   Main := Header Decls Footer Rules 
+   Main := Header Decls Footer Rules
 
    first  symbols:codetok
-   
+
    cannot reachend
 */
 
@@ -4899,10 +4899,10 @@ static void Main (pge_SetOfStop stopset)
 
 
 /*
-   Header := '%' 'module' StartModName 
+   Header := '%' 'module' StartModName
 
    first  symbols:codetok
-   
+
    cannot reachend
 */
 
@@ -4915,10 +4915,10 @@ static void Header (pge_SetOfStop stopset)
 
 
 /*
-   Decls := '%' 'declaration' DoDeclaration 
+   Decls := '%' 'declaration' DoDeclaration
 
    first  symbols:codetok
-   
+
    cannot reachend
 */
 
@@ -4931,10 +4931,10 @@ static void Decls (pge_SetOfStop stopset)
 
 
 /*
-   Footer := '%' 'module' EndModName 
+   Footer := '%' 'module' EndModName
 
    first  symbols:codetok
-   
+
    cannot reachend
 */
 
@@ -4947,16 +4947,16 @@ static void Footer (pge_SetOfStop stopset)
 
 
 /*
-   First := 'first' '{' { LitOrTokenOrIdent 
+   First := 'first' '{' { LitOrTokenOrIdent
                           % WITH CurrentSetDesc^ DO
                                next := TailProduction^.first ;
                             END ;
                             TailProduction^.first := CurrentSetDesc
                              %
-                           } '}' 
+                           } '}'
 
    first  symbols:firsttok
-   
+
    cannot reachend
 */
 
@@ -4976,16 +4976,16 @@ static void First (pge_SetOfStop stopset)
 
 
 /*
-   Follow := 'follow' '{' { LitOrTokenOrIdent 
+   Follow := 'follow' '{' { LitOrTokenOrIdent
                             % WITH CurrentSetDesc^ DO
                                  next := TailProduction^.followinfo^.follow ;
                               END ;
                               TailProduction^.followinfo^.follow := CurrentSetDesc
                                %
-                             } '}' 
+                             } '}'
 
    first  symbols:followtok
-   
+
    cannot reachend
 */
 
@@ -5005,25 +5005,25 @@ static void Follow (pge_SetOfStop stopset)
 
 
 /*
-   LitOrTokenOrIdent := Literal 
+   LitOrTokenOrIdent := Literal
                         % CurrentSetDesc := NewSetDesc() ;
                           WITH CurrentSetDesc^ DO
                              type   := litel ;
                              string := LastLiteral ;
                           END ;
                            %
-                         | '<' CollectTok '>'  | 
-                        Ident 
+                         | '<' CollectTok '>'  |
+                        Ident
                         % CurrentSetDesc := NewSetDesc() ;
                           WITH CurrentSetDesc^ DO
                              type   := idel ;
                              ident  := CurrentIdent ;
                           END ;
                            %
-                        
+
 
    first  symbols:dquotetok, squotetok, identtok, lesstok
-   
+
    cannot reachend
 */
 
@@ -5060,11 +5060,11 @@ static void LitOrTokenOrIdent (pge_SetOfStop stopset)
 
 
 /*
-   Literal := '"' CollectLiteral '"'  | 
-              "'" CollectLiteral "'" 
+   Literal := '"' CollectLiteral '"'  |
+              "'" CollectLiteral "'"
 
    first  symbols:squotetok, dquotetok
-   
+
    cannot reachend
 */
 
@@ -5092,10 +5092,10 @@ static void Literal (pge_SetOfStop stopset)
 
 
 /*
-   Token := Literal DefineToken 
+   Token := Literal DefineToken
 
    first  symbols:dquotetok, squotetok
-   
+
    cannot reachend
 */
 
@@ -5107,14 +5107,14 @@ static void Token (pge_SetOfStop stopset)
 
 
 /*
-   ErrorProcedures := Literal 
+   ErrorProcedures := Literal
                       % ErrorProcArray := LastLiteral  %
-                      Literal 
+                      Literal
                       % ErrorProcString := LastLiteral  %
-                      
+
 
    first  symbols:dquotetok, squotetok
-   
+
    cannot reachend
 */
 
@@ -5128,12 +5128,12 @@ static void ErrorProcedures (pge_SetOfStop stopset)
 
 
 /*
-   TokenProcedure := Literal 
+   TokenProcedure := Literal
                      % TokenTypeProc := LastLiteral  %
-                     
+
 
    first  symbols:dquotetok, squotetok
-   
+
    cannot reachend
 */
 
@@ -5145,12 +5145,12 @@ static void TokenProcedure (pge_SetOfStop stopset)
 
 
 /*
-   SymProcedure := Literal 
+   SymProcedure := Literal
                    % SymIsProc := LastLiteral  %
-                   
+
 
    first  symbols:dquotetok, squotetok
-   
+
    cannot reachend
 */
 
@@ -5162,10 +5162,10 @@ static void SymProcedure (pge_SetOfStop stopset)
 
 
 /*
-   Production := Statement 
+   Production := Statement
 
    first  symbols:identtok
-   
+
    cannot reachend
 */
 
@@ -5176,25 +5176,25 @@ static void Production (pge_SetOfStop stopset)
 
 
 /*
-   Expression := 
+   Expression :=
                  % VAR t1, t2: TermDesc ;
                        e     : ExpressionDesc ;  %
-                 
+
                  % e := CurrentExpression ;
                    t1 := NewTerm() ;
                    CurrentTerm := t1 ;  %
-                 Term 
+                 Term
                  % e^.term := t1 ;  %
-                 { '|' 
+                 { '|'
                    % t2 := NewTerm() ;
                      CurrentTerm := t2  %
-                   Term 
+                   Term
                    % t1^.next := t2 ;
                      t1 := t2  %
-                    } 
+                    }
 
    first  symbols:dquotetok, squotetok, lparatok, lsparatok, lcparatok, identtok, codetok
-   
+
    cannot reachend
 */
 
@@ -5223,25 +5223,25 @@ static void Expression (pge_SetOfStop stopset)
 
 
 /*
-   Term := 
+   Term :=
            % VAR    t1: TermDesc ; f1, f2: FactorDesc ;  %
-           
+
            % CurrentFactor := NewFactor() ;
              f1 := CurrentFactor ;
              t1 := CurrentTerm ;  %
-           Factor 
+           Factor
            % t1^.factor := f1 ;
              f2 := NewFactor() ;
              CurrentFactor := f2  %
-           { Factor 
+           { Factor
              % f1^.next := f2 ;
                f1 := f2 ;
                f2 := NewFactor() ;
                CurrentFactor := f2 ;  %
-              } 
+              }
 
    first  symbols:squotetok, dquotetok, codetok, identtok, lcparatok, lsparatok, lparatok
-   
+
    cannot reachend
 */
 
@@ -6321,7 +6321,7 @@ static void CodeFactor (pge_FactorDesc f, pge_TermDesc t, pge_m2condition l, pge
             CodeExpression (f->expr, pge_m2none, inopt, inwhile, consumed, NULL);
             if (f->next != NULL)
               {
-                /* 
+                /*
                     *  the test above makes sure that we don't emit a RETURN( TRUE )
                     *  after a subexpression. Remember sub expressions are not conditional
   */
@@ -6725,7 +6725,7 @@ static void EmitIsInFirst (pge_SetDesc to, pge_m2condition m)
 
 static void FlushRecoverCode (pge_FactorDesc *codeStack)
 {
-  /* 
+  /*
    FlushCode -
   */
   if ((*codeStack) != NULL)
@@ -7382,7 +7382,7 @@ static void EmitStopParametersAndFollow (pge_FactorDesc f, pge_m2condition m)
   pge_SetDesc to;
 
   to = NULL;
-  /* 
+  /*
    IF m=m2while
    THEN
       CalcFirstFactor(f, NIL, to)
@@ -7490,6 +7490,7 @@ static bool FindStr (pge_CodeHunk *code, unsigned int *i, const char *str_, unsi
   /* make a local copy of each unbounded array.  */
   memcpy (str, str_, _str_high+1);
 
+  j = StrLib_StrLen ((const char *) str, _str_high);
   t = (*code);
   k = (StrLib_StrLen ((const char *) &(*code)->codetext.array[0], MaxCodeHunkLength))+1;
   while (t != NULL)
@@ -7952,7 +7953,7 @@ static void WorkOutFollowFactor (pge_FactorDesc f, pge_SetDesc *followset, pge_S
   pge_TraverseResult foundepsilon;
   pge_TraverseResult canreachend;
 
-  /* 
+  /*
    WorkOutFollow -
   */
   foundepsilon = pge_true;
@@ -8323,7 +8324,7 @@ static void CalcEpsilonProduction (pge_ProductionDesc p)
 {
   if (p != NULL)
     {
-      /* 
+      /*
       IF p^.statement^.ident^.name=MakeKey('DefinitionModule')
       THEN
          stop
diff --git a/gcc/m2/pge-boot/Gtermios.cc b/gcc/m2/pge-boot/Gtermios.cc
index 5f966403b19..55220e7624e 100644
--- a/gcc/m2/pge-boot/Gtermios.cc
+++ b/gcc/m2/pge-boot/Gtermios.cc
@@ -1081,8 +1081,8 @@ EXPORT (GetFlag) (struct termios *t, Flag f, int *b)
 /* SetFlag - sets a flag value in, t, to, b, and returns TRUE if this
    flag value is supported.  */
 
-int
-EXPORT (SetFlag) (struct termios *t, Flag f, int b)
+bool
+EXPORT (SetFlag) (struct termios *t, Flag f, bool b)
 {
   switch (f)
     {
@@ -1933,12 +1933,12 @@ EXPORT (SetChar) (struct termios *t, ControlChar c, char ch)
 }
 
 void
-_M2_termios_init (void)
+_M2_termios_init (int argc, char *argv[], char *envp[])
 {
 }
 
 void
-_M2_termios_fini (void)
+_M2_termios_fini (int argc, char *argv[], char *envp[])
 {
 }
 
diff --git a/gcc/m2/pge-boot/m2rts.h b/gcc/m2/pge-boot/m2rts.h
index 7345074953a..fe9745b1aa6 100644
--- a/gcc/m2/pge-boot/m2rts.h
+++ b/gcc/m2/pge-boot/m2rts.h
@@ -28,8 +28,13 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 typedef void (*proc_con) (int, char **, char **);
 typedef void (*proc_dep) (void);
 
+#define M2RTS_RegisterModule_Cstr(MODNAME,LIBNAME,init,fini,dep) \
+  M2RTS_RegisterModule (reinterpret_cast <void *> (const_cast <char *> (MODNAME)), \
+			reinterpret_cast <void *> (const_cast <char *> (LIBNAME)), \
+			init, fini, dep)
+
 extern "C" void M2RTS_RequestDependant (const char *modulename, const char *dependancy);
-extern "C" void M2RTS_RegisterModule (const char *modulename, const char *libname,
+extern "C" void M2RTS_RegisterModule (void *modulename, void *libname,
 				      proc_con init, proc_con fini, proc_dep dependencies);
 extern "C" void _M2_M2RTS_init (void);
 

